import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


 public class AGMap {

     public AGMap() {}

     public static int[] forwardMap(int p,int q,double m,double n) {
	int[] test1=plusMap(p,q,m,n);
	int[] test2=minusMap(p,q,m,n);
	int parity=parity(p,q,m,n);
	if(parity==0) {
	    int[] I={test1[0],test1[1]};
	    return(I);
	}
	int[] I={test2[0],test2[1]};
	return(I);
     }

     public static int[] backwardMap(int p,int q,double m,double n) {
	int[] test1=plusMap(p,q,m,n);
	int[] test2=minusMap(p,q,m,n);
	int parity=parity(p,q,m,n);
	if(parity==1) {
	    int[] I={test1[0],test1[1]};
	    return(I);
	}
	int[] I={test2[0],test2[1]};
	return(I);
     }


     public static int parity(int p,int q,double m,double n) {
	 double A=1.0*p/q;
	 double x=A*m+m+.5/q;
	 int y=(int)(Math.floor(x));
	 return (y+100000)%2;
     }

     public static int[] plusMap(int p,int q,double m,double n) {
	 double[] d=phiPlus(p,q,m,n);
	 double A=1.0*p/q;
	    int[] N=characteristics(A,d[0],d[1],d[2]);
	    N[0]=0;  
	    int[] s=new int[2];
	    s[0]=getX(N[0],N[1],N[2],N[3],N[4]);
	    s[1]=getY(N[0],N[1],N[2],N[3],N[4]);
	    return(s);
	}

     public static int[] minusMap(int p,int q,double m,double n) {
	  double[] d=phiMinus(p,q,m,n);	
           double A=1.0*p/q;
	    int[] N=characteristics(A,d[0],d[1],d[2]);
	    N[0]=1;  
	    int[] s=new int[2];
	    s[0]=getX(N[0],N[1],N[2],N[3],N[4]);
	    s[1]=getY(N[0],N[1],N[2],N[3],N[4]);
	    return(s);
	}



     /**lattice reduction algorithms*/

	public static double fractionalPart(double x) {
	    return(x-Math.floor(x));
	}

	public static double fractionalPart(double d,double x) {
	    double y=d*fractionalPart(x/d);
	    return(y);
	}

     public static Vector4 reduceLattice(Vector4 V) {
	 double[] d=reduceLattice(V.x[3],V.x[0],V.x[1],V.x[2]);
	 Vector4 W=new Vector4(d[0],d[1],d[2],V.x[3]);
	 return W;
     }

	public static double[] reduceLattice(double A,double x1,double x2,double x3) {
	    double r1=reduce(-1,1,x3,x1);
	    double r2=reduce(-1,1,x2,x1);
	    double n1=reduce(1-A,1+A,r1,r2);      
	    double X1=fractionalPart(1+A,n1);      
            double X2=fractionalPart(1+A,r2);      
	    double[] z={x1-Math.floor(x1),X2,X1};
	    return(z);
	}

	public static double reduce(double v1,double v2,double x1,double x2) {
	    double number=Math.floor(x2/v2);
	    return(x1-v1*number);
	}

     /**The maps.  We don't use phi+ and phi- in the paper but it is
        useful to keep them around.*/

     public static double[] phi(int p,int q,double m,double n) {
            double s=1.0*p*m/q+n+.5/q;
	    double[] a=reduceLattice(1.0*p/q,s,s,s);
	    return(a);
	}

     public static double[] phiPlus(int p,int q,double m,double n) {
	    double s=1.0*p*m/q+n+.5/q;
	    double[] a=reduceLattice(1.0*p/q,s,s+1,s);
	    return(a);
	}

     public static double[] phiMinus(int p,int q,double m,double n) {
            double s=1.0*p*m/q+n+.5/q;
	    double[] a=reduceLattice(1.0*p/q,s,s,s-1);
	    return(a);
	}

     /**determining the local types */

	public static int[] characteristics(double A,double x,double y,double z) {
	    int[] N=new int[5];

	    N[1]=0;
            if((x<A)&&(x<1-A)) N[1]=0;
	    if((x>A)&&(x<1-A)) N[1]=1;
	    if((x>A)&&(x>1-A)) N[1]=2;
	    if((x<A)&&(x>1-A)) N[1]=3;

	    N[2]=2;
	    if(z<1) N[2]=1;
	    if(z<A) N[2]=0;

	    N[3]=2;
	    if(y<1) N[3]=1;
	    if(y<A) N[3]=0;

	    double t=z+y-x;
	    N[4]=(int)(Math.floor(t-A));
	    return(N);
	}


      public static int getX(int mode,int region,int x,int y,int t) {
        int tt=t+4;
        if(((tt+mode)%2==0)&&((x+y==4)||(x<y))) return(-1);
        if(((tt+mode)%2==1)&&((x+y==0)||(x>y))) return(1);
        return(0);
      }


     public static int getY(int mode,int region,int x,int y,int t) {

        if(((region==3)||(region==0))&&(mode==0)) {        
	    if(x==0) return(1);
	    if((x==1)&&(t!=0)) return(1);
        }

        if(((region==0)||(region==1))&&(mode==1)) {       
	    if((x>0)&&(t!=0)) return(-1);
	    if((y==0)&&(x<2)&&(t==0)) return(1);
        }

        if(((region==1)||(region==2))&&(mode==0)) {
	    if((x<2)&&(t!=0)) return(1);
	    if((y==2)&&(x>0)&&(t==0)) return(-1);
        }

        if(((region==2)||(region==3))&&(mode==1)) {
	    if(x==2) return(-1);
	    if((x==1)&&(t!=0)) return(-1);
        }
        return(0);
      }




 }