import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


/**This class retrieves the the polytopes from the 4 partitions:
-graph PET partition
-plaid PET partition
-graph triple partition 
-plaid triple partition
All polytopes are scaled up by 60 to clear denominators. */

public class AllPolytopes {

    public static Polytope graph(int k) {
	int[][] P1=DataGraphPolytopes.data(k);
	Polytope X=new Polytope();
	X.count=P1.length;
	for(int i=0;i<P1.length;++i) {
	    X.V[i]=new Vector4(P1[i][0],P1[i][1],P1[i][2],P1[i][3]);
	}
	int[] type=DataGraphPolytopes.type(k);
	X.type[1]=type[0];
	X.type[2]=type[1];
	return(X);
    }

    public static Polytope plaid(int k) {
	int[][] P1=DataPlaidPolytopes.data(k);
	Polytope X=new Polytope();
	X.count=P1.length;
	for(int i=0;i<P1.length;++i) {
	    X.V[i]=new Vector4(P1[i][0],P1[i][1],P1[i][2],P1[i][3]);
	}
	int[] type=DataPlaidPolytopes.type(k);
	X.type[1]=type[0];
	X.type[2]=type[1];
	return(X);
    }


    public static Polytope graphDouble(int k) {
	int[][] P1=DataGraphDoubles.data(k);
	Polytope X=new Polytope();
	X.count=P1.length;
	for(int i=0;i<P1.length;++i) {
	    X.V[i]=new Vector4(P1[i][0],P1[i][1],P1[i][2],P1[i][3]);
	}
	return(X);
    }

    public static Polytope graphTriple(int k) {

	int[][] P1=DataGraphTriples.data(k);
	Polytope X=new Polytope();
	X.count=P1.length;
	for(int i=0;i<P1.length;++i) {
	    X.V[i]=new Vector4(P1[i][0],P1[i][1],P1[i][2],P1[i][3]);
	    X.V[i]=X.V[i].scale(1.0/60);
	}
	int[][] Q0=DataTripleCodes.data();
	int[] Q1=Q0[k];
	for(int i=0;i<6;++i) X.code[i]=Q1[i];
	return(X);
    }

    public static Polytope plaidTriple(int k) {
	int[][] P1=DataPlaidTriples.data(k);
	Polytope X=new Polytope();
	X.count=P1.length;
	for(int i=0;i<P1.length;++i) {
	    X.V[i]=new Vector4(P1[i][0],P1[i][1],P1[i][2],P1[i][3]); 
            X.V[i]=X.V[i].scale(1.0/60);
	}
	int[][] Q0=DataTripleCodes.data();
	int[] Q1=Q0[k];
	for(int i=0;i<6;++i) X.code[i]=Q1[i];
	return(X);
    }

    public static Polytope plaidBarrier(int k) {
	int[][] P1=DataPlaidBarriers.data(k);
	Polytope X=new Polytope();
	X.count=P1.length;
	for(int i=0;i<P1.length;++i) {
	    X.V[i]=new Vector4(P1[i][0],P1[i][1],P1[i][2],P1[i][3]);
	}
	return(X);
    }


    public static int getPlaidIndex(Vector4 W) {
	Vector4 V=PlaidClassifyingMap.reduce2(W);
	for(int i=0;i<218;++i) {
	    Polytope POLY=plaidTriple(i);
	    if(POLY.contains(V)==true) return i;
	}
	return(-1);
    }

}
