import java.applet.Applet;
import java.awt.*;
import java.applet.*;
import java.math.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.Arrays;
import java.math.*;

public class Conversion {

    public static void testCoherence() {
	int count=0;
	String[] LIST=new String[2000];
	int badcount=0;
	for(int q=2;q<50;++q) {
	    for(int p=1;p<q;++p) {
		String[] TEMP=coherence(p,q);
		if(TEMP!=null) {
		  for(int i=0;i<TEMP.length;++i) {
		    if(onList(TEMP[i],LIST,count)==false) {
			System.out.print(count+":  ");
			System.out.println(TEMP[i]);
			LIST[count]=new String(TEMP[i]);
			++count;
		    }
		  }
		}
	    }
	}
	System.out.println("done");
    }





    public static String[] coherenceX(int p,int q) {
	if(MathRational.GCD(p,q)!=1) return null;
	if((p*q)%2==1) return null;
	String[] LIST=new String[200];
	int count=0;
	String[] X=totalPlaidCodon(p,q);
	String[] Y=totalGraphCodon(p,q);
	for(int i=0;i<X.length;++i) {
	    String test1=getMid(X[i]);
	    if(test1.equals(Y[i])==false) {
		if(Y[i].equals("99")==false) {
	           String TEMP=X[i]+" "+Y[i];
	           if(onList(TEMP,LIST,count)==false) {
		     LIST[count]=new String(TEMP);
		     ++count;
		   }
	       }
	    }
	}
	String[] LIST2=new String[count];
	for(int i=0;i<count;++i) LIST2[i]=new String(LIST[i]);
	return(LIST2);
    }

    public static String[] coherence(int p,int q) {
	if(MathRational.GCD(p,q)!=1) return null;
	if((p*q)%2==1) return null;
	String[] LIST=new String[200];
	int count=0;
	String[] X=totalPlaidCodon(p,q);
	String[] Y=totalGraphCodon(p,q);
	for(int i=0;i<X.length;++i) {
	    for(int j=i+1;j<X.length;++j) {
		if(X[i].equals(X[j])==true) {
		    if(equals(Y[i],Y[j])==false) {
			String TEMP=X[i]+" "+Y[i]+" "+Y[j];
			if(onList(TEMP,LIST,count)==false) {
			   LIST[count]=new String(TEMP);
			   ++count;
			}
		    }
		}
	    }
	}
	String[] LIST2=new String[count];
	for(int i=0;i<count;++i) LIST2[i]=new String(LIST[i]);
	return(LIST2);
    }



    public static boolean onList(String S,String[] LIST,int count) {
	for(int i=0;i<count;++i) {
	    if(S.equals(LIST[i])==true) return(true);
	}
	return(false);
    }

    public static String getMid(String S) {
	return(S.substring(6,8));
    }




    public static boolean equals(String S,String T) {
	if(S.equals("9999")==true) return(true);
	if(T.equals("9999")==true) return(true);
	if(S.equals("99")==true) return(true);
	if(T.equals("99")==true) return(true);
	return S.equals(T);
    }

    public static String[] totalPlaidCodon(int p,int q) {
	int w=p+q;
	String[] S=new String[w*w*w];
	int count=0;
	for(int i=0;i<w*w;++i) {
	    for(int j=0;j<w;++j) {
		S[count]=plaidCodon(p,q,i,j);
		++count;
	    }
	}
	return(S);
    }

    public static String[] totalGraphCodon(int p,int q) {
	int w=p+q;
	String[] S=new String[w*w*w];
	int count=0;
	for(int i=0;i<w*w;++i) {
	    for(int j=0;j<w;++j) {
		S[count]=graphCodon(p,q,i,j); 

		++count;
	    }
	}
	return(S);
    }


    public static String plaidCodon(int p,int q,int a,int b) {
	String S=new String();
	for(int i=a-1;i<a+2;++i) {
	    for(int j=b-1;j<b+2;++j) {
		if((a+b+i+j+100000)%2==0) {
	           Tile T=new Tile(p,q,i,j);
	           int[] I=Cubical.classify(T);
	           S=S+type(I)+" ";
		}
	    }
	}
	return(S);
    }


    public static String[] totalSpiderCodon(int p,int q) {
	int w=p+q;
	String[] S=new String[w*w*w];
	int count=0;
	for(int i=0;i<w*w;++i) {
	    for(int j=0;j<w;++j) {
		S[count]=spiderCodon(p,q,i,j);
		++count;
	    }
	}
	return(S);
    }




    public static String type(int[] I) {
	int count=0;
	int[] J={I[0],I[1]};
	Arrays.sort(J);
	Integer J0=new Integer(J[0]);
	Integer J1=new Integer(J[1]);
	String S=J0.toString()+J1.toString();
	return(S);
    }

    public static String graphCodon(int p,int q,int x,int y) {
	String S="";
	double A=1.0*p/q;
	if(goodPoint(p,q,x+.5,y+.5)==false) return("9999");
        Complex z=AGLattice.nearestGrid(p,q,x+.5,y+.5);
	Complex w=AGTransforms.directMap(p,q,z);
        int[] test1=AGMap.forwardMap(p,q,w.x,w.y);
	int[] test2=AGMap.backwardMap(p,q,w.x,w.y);
	int c1=10*(test1[0]+2)+(test1[1]+2);
	int c2=10*(test2[0]+2)+(test2[1]+2);
	int[] test3={c1,c2};
	Arrays.sort(test3);
	for(int i=0;i<2;++i) {
	    Integer I=new Integer(test3[i]);
	    S=S+I.toString();
	}
	return(S);
    }

    public static String spiderCodon(int p,int q,int x,int y) {
	String S="";
	double A=1.0*p/q;
	if(goodPointStrict(p,q,x+.5,y+.5)==false) return("99");
        Complex z=AGLattice.nearestGrid(p,q,x+.5,y+.5);
	Complex w=AGTransforms.directMap(p,q,z);
        int[] test1=AGMap.forwardMap(p,q,w.x,w.y);
	int[] test2=AGMap.backwardMap(p,q,w.x,w.y);
	if((test1[0]==0)&&(test1[1]==0)) return("99");
	int s1=Spider.codon0(p,q,z,test1[0],test1[1]);
	int s2=Spider.codon0(p,q,z,test2[0],test2[1]);
	int[] s={s1,s2};
	Arrays.sort(s);
	Integer I1=new Integer(s[0]);
	Integer I2=new Integer(s[1]);
	S=I1.toString()+I2.toString();
	if(S.equals("11")==true) {
	    System.out.println(p+"/"+q);
	    System.out.println(x+" "+y);
	    z.print();
	    System.out.println(test1[0]+" "+test1[1]+"  "+test2[0]+" "+test2[1]);
	    System.out.println(1/0);
	}
	return(S);
    }

    public static int toInt(String S) {
	Integer X=new Integer(S);
	return X.intValue();
    }

    public static boolean goodPoint(int p,int q,double x,double y) {
	Complex z=AGLattice.nearestGrid(p,q,x,y);
	double x2=Math.floor(x)+.5;
	double y2=Math.floor(y)+.5;
	if(Math.abs(z.y-y2)>.5000001) return(false);
	if(z.x<x2-.5000001) return(false);
	if(z.x>x2+.4999999) return(false);
	return(true);
    }

    public static boolean goodPointStrict(int p,int q,double x,double y) {
	Complex z=AGLattice.nearestGrid(p,q,x,y);
	double x2=Math.floor(x)+.5;
	double y2=Math.floor(y)+.5;
	if(Math.abs(z.x-x2)>.499999) return(false);
	if(Math.abs(z.y-y2)>.499999) return(false);
	return(true);
    }


}



