public class DataGraphDoubles {

    /**18 of the graph PET triples do not lie in single polytopes of the (+) 
graph PET partition.  However, each of them lies in one of 4 doubles.
Likewise, 18 of the graph PET triples do not lie in single polytopes of the (-) 
graph PET partition.  However, each of them lies in one of 5 doubles.  Here are
the vertices of these 9=4+5 doubles*/

public static int[][] data(int k) {
    int[][][] P={{{0,0,1,1},{1,1,1,1},{0,-1,0,0},{0,0,0,0},{1,1,0,1},{0,1,0,1},{1,0,0,0},{1,0,1,1},{0,0,0,1}},{{1,0,0,0},{0,0,0,0},{1,0,1,0},{1,0,2,1},{0,0,1,1},{1,1,1,1},{1,0,1,1}},{{1,0,2,0},{0,1,0,1},{1,3,0,1},{1,2,1,1},{0,1,1,1},{1,0,1,0},{0,0,1,0},{1,1,1,1},{0,2,0,1},{1,2,0,1},{1,1,1,0}},{{0,0,1,0},{0,1,1,0},{1,3,0,1},{1,3,1,1},{0,1,1,1},{0,2,1,1},{0,3,0,1},{1,2,1,1},{0,2,0,1}},{{1,0,1,1},{1,0,1,0},{1,2,0,1},{0,0,0,1},{0,0,1,1},{1,1,1,1},{0,1,0,1},{1,1,1,0},{1,1,0,1}},{{1,2,0,1},{0,1,0,0},{1,1,1,0},{1,2,1,1},{0,0,1,1},{0,2,0,1},{0,0,1,0},{0,1,1,0},{1,1,1,1},{0,1,0,1},{0,1,1,1}},{{1,0,2,0},{0,1,2,1},{0,0,1,0},{1,1,2,1},{0,1,1,1},{0,0,2,1},{0,0,2,0}},{{0,0,0,1},{0,0,1,0},{0,0,0,0},{1,1,0,1},{0,1,0,1},{0,1,-1,1},{1,0,1,0}},{{0,0,0,1},{0,0,1,1},{0,1,0,1},{1,0,1,1},{1,1,1,0},{1,1,1,1},{0,0,1,0},{1,0,1,0},{1,1,0,1}}};
    return P[k];
}

    /**This keeps track of how the double polytopes are created.  For instance, the code (-1,0,0,15,18) indicates that we should take the union of P15 and P18 and then apply the group action (-1,0,0) the result.*/

    public static int[] code(int k) {
	int[][] a={{0,0,0,0,7},{0,0,0,2,9},{0,1,0,1,4},{0,1,0,0,5},{-1,0,0,14,19},{-1,0,0,15,18},{0,0,0,16,23},{-1,0,0,16,23},{-1,0,0,14,21}};
	return(a[k]);
    }

    /**The graph triples indexed 180,...,217 are the ones which are not contained in single
       polytopes.  This tells which of our 9 doubles contains the given triple.*/

    public static int whichContainer(int k) {
	if(k<180) return(-1);
	int[] c={1,2,0,0,1,0,1,1,0,3,3,0,1,1,3,0,0,1,0,4,5,7,8,7,7,7,8,6,4,8,8,8,8,7,4,8,7,8};
	return(c[k-180]);
    }

}

