import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class PlaidPETCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener, KeyListener {
    Manager M;
    Color[] COLOR=new Color[7];
    Point JX;
    ControlPanel SLOPE;

    public PlaidPETCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 setScales(200,200,180);	
     }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                         RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);


      if(M.C.PLAID.L[0].on==1) {
	  drawPartition(g); 
	  drawImage(g);
      }

      if(M.C.PLAID.L[1].on==1) {
	  drawTriple(g);  
          drawImage(g);
      }

      if(M.C.PLAID.L[2].on==1) {
	  drawTripleSelect(g);  
          drawImage(g);
      }

      if(M.C.PLAID.L[3].on==1) {
	  hitset(g);
      }

      if(M.C.PLAID.L[4].on==1) {
	  drawBarriers(g);
      }

      if(M.C.SANITY.L[0].on==1) {
	  drawClassMap(g);
       }

      if(M.C.SANITY.L[1].on==1) {
	  M.C.WAL.draw(g,this);
      }

      if(M.C.SANITY.L[2].on==1) {
         drawParticle(g);
      }

      if(M.C.SANITY.L[3].on==1) {
         plotHitset(g);
      }
   }


    public void drawBG(Graphics2D g) {
	g.setColor(new Color(0,0,0));
        g.fillRect(0,0,getWidth(),getHeight()); 
    }


    /**this draws the image under the classifying map.*/

    public void drawImage(Graphics2D g) {
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(SOURCE.x,SOURCE.y);
	gp.lineTo(SOURCE.x,SOURCE.y);
	gp=transform(gp);
	g.setColor(Color.white);
	g.setStroke(new BasicStroke(6));
	g.fill(gp);
	g.draw(gp);
	g.setColor(Color.black);
	g.setStroke(new BasicStroke(3));
	g.fill(gp);
	g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }



    /**These routines draw the polytope partition*/

    public void fillPoly(Graphics2D g,Path2D.Double gp,Color C) {
       gp=transform(gp);
       g.setColor(C);
       g.fill(gp);  
       g.setColor(Color.white);
       g.draw(gp);
    }


    /**This is for displaying the polytope vertices*/
    public void polyInfo(Path2D.Double gp,int q1,int q2,int q3,int k) {
	if(gp.contains(SOURCE.x,SOURCE.y)==true) {
	    try{   
		int[] ty=DataPlaidPolytopes.type(k);
		if((q1+10)%2==1) {
		    int a=ty[1];
		    ty[1]=ty[0];
		    ty[0]=a;
		}
                int[] S={q1,q2,q3,ty[0],ty[1]};
		int[] LIST={1};
		M.I.LIST=LIST;
		M.I.POLY[1]=k;
		M.I.DATA=S;
	    }
	    catch(Exception e) {}
	}
    }




    public void drawPartition(Graphics2D g) {
	int lim1=-2;
	int lim2=2;
	try{
	    lim1=-M.QS.TILE.val;
	    lim2=+M.QS.TILE.val;
	}
	catch(Exception e) {}
	for(int a1=lim1;a1<=lim2;++a1) {
	    for(int a2=lim1;a2<=lim2;++a2) {
		for(int a3=lim1;a3<=lim2;++a3) {
		    PolygonWrapper[] LIST=getPoly(a1,a2,a3);
	            for(int i=0;i<LIST.length;++i) {
	               Path2D.Double gp=LIST[i].toPath2D();
	               int t1=LIST[i].t1;
	               int t2=LIST[i].t2;
	               Color C=PlaidPETColors.COLOR[t1][t2];
	               fillPoly(g,gp,C);
		       polyInfo(gp,a1,a2,a3,LIST[i].index);
		    }
		}
	    }
	}
    }



    public PolygonWrapper[] getPoly(int a1,int a2,int a3) {	
	int count=0;  
	int s=0;
	double t=0;
	double P=1/2;
	int dyn=1;
	try{
	   s=M.QS.DIRECTION.mode;   
           t=M.QS.getSlice();
	   P=M.QS.getParameter();
	   dyn=M.QS.getDynamics();
	}
	catch(Exception e) {}
    
	PolygonWrapper[] LIST=new PolygonWrapper[26];
        for(int i=0;i<26;++i) { 
            Polytope POLY=AllPolytopes.plaid(i);
	    POLY=PlaidPolytopeMoves.shift(a1,a2,a3,POLY);
	    POLY=PlaidPolytopeMoves.map(dyn,POLY);
	    PolygonWrapper SPOLY=POLY.slice(s,t,P);
	    if(SPOLY!=null) { 
		LIST[count]=new PolygonWrapper(SPOLY);
		LIST[count].t1=POLY.type[1];
		LIST[count].t2=POLY.type[2];
		LIST[count].index=i;
		++count;
	    }
	}
	return ListHelp.trim(LIST,count);
    }

    /**draws the triple partition.*/

    public void drawTriple(Graphics2D g) {
	int p=M.p();
	int q=M.q();
	int s=M.QS.DIRECTION.mode;  
	int dyn=M.QS.DYNAMICS.mode; 
        double t=M.QS.getSlice();
	double P=M.QS.getParameter();
	for(int i=0;i<218;++i) {
	    Polytope FINAL=AllPolytopes.plaidTriple(i);
            PolygonWrapper SPOLY=FINAL.slice(s,t,P);
	     if(SPOLY!=null) {
	       Path2D.Double gp=SPOLY.toPath2D();
	       int t1=0;
	       int t2=0;
	       if(dyn==0) {t1=FINAL.code[2];t2=FINAL.code[3];}
	       if(dyn==1) {t1=FINAL.code[4];t2=FINAL.code[5];}
	       if(dyn==2) {t1=FINAL.code[0];t2=FINAL.code[1];}
               Color C=PlaidPETColors.COLOR[t1][t2];
	       fillPoly(g,gp,C);
	     }
	}
	makeFrame(g);
    }



    public void drawTripleSelect(Graphics2D g) {
	int s=M.QS.DIRECTION.mode;  
	int dyn=M.QS.DYNAMICS.mode; 
        double t=M.QS.getSlice();
	double P=M.QS.getParameter();
	for(int i=0;i<218;++i) {
	    Polytope POLY=AllPolytopes.plaidTriple(i);
	    POLY.type[1]=POLY.code[2];
	    POLY.type[2]=POLY.code[3];
	    boolean test=false;
	    try{test=M.Z.TS.matchesCode(POLY,i);}
	    catch(Exception e) {}
	    if(test==true) {
               PolygonWrapper SPOLY=POLY.slice(s,t,P);
	       if(SPOLY!=null) {
	          Path2D.Double gp=SPOLY.toPath2D();
	          int t1=0;
	          int t2=0;
	          Color C=Color.black;
	          if(dyn==0) {t1=POLY.code[2];t2=POLY.code[3];}
	          if(dyn==1) {t1=POLY.code[4];t2=POLY.code[5];}
	          if(dyn==2) {t1=POLY.code[0];t2=POLY.code[1];}
                  C=PlaidPETColors.COLOR[t1][t2];
    	          g.setStroke(new BasicStroke(3));
	          fillPoly(g,gp,C);
	       }

	    }
	}
	makeFrame(g);
    }




    /**This draws the image of the given point
       under the classifying map*/
    public void drawClassMap(Graphics2D g) {
	Path2D.Double gp=new Path2D.Double();
	int p=M.C.PAR.getNumerator();
	int q=M.C.PAR.getDenominator();
	double A=1.0*p/q;
	double P=2.0*p/(p+q);
	int k=p+q;
	Tile T=new Tile();

	double min=M.QS.getSlice()-1.0/(p+q);
	double max=min+2.0/(p+q);
	int lim=-k;
	double[] U={0,0,0,0};
        for(int i=0;i<2*k*k;++i) {
	    for(int j=lim;j<k;++j) {
		U=PlaidClassifyingMap.mapEnhanced(P,new Complex(i+.5,j+.5));
	        if((U[0]>min)&&(U[0]<max)) { 
                  T=new Tile(p,q,i,j);
		  int[] I=PlaidClassify.classify(T);
		  gp=makeSquare(p,q,U[1],U[2]);
		  g.setColor(PlaidPETColors.COLOR[I[0]][I[1]]);
		  gp=transform(gp);
		  g.fill(gp);
	    }
	  }
	}
      makeFrame(g);
    }


    /**This draws the images of the symmetric points
       in the plaid grid, classifying them according to
       type: vertical P West, etc.  This does something
       different for the two cases.

       vertical: Draws either the T,U1 picture
       or the T,U2 picture.

       horizontal, draws the T-slice.
    */

    public void drawSymmetricPoint(Graphics2D g) {}


    public void drawParticle(Graphics2D g) {
	Path2D.Double gp=new Path2D.Double();	
	int p=M.C.PAR.getNumerator();
	int q=M.C.PAR.getDenominator();
	double P=2.0*p/(p+q);
	int a=MathRational.tune(p,q,p+q-1);
	Complex z=new Complex(0,0);
	Complex c=new Complex();
	    int lim=0;
	    for(int choice=0;choice<2;++choice) {
	         if(choice==0) lim=2*p;
	         if(choice==1) lim=2*q;
	         for(int i=0;i<lim;++i) {
	  	  c.x=Math.floor(z.x)+.5;
		  c.y=z.y+.5;
 	          double[] U=PlaidClassifyingMap.mapEnhanced(P,c.x,c.y);
	          gp=makeSquare(p,q,U[0],U[2]);
	          gp=transform(gp);
	          g.setColor(Color.red);  
                  g.fill(gp);
	          g.setColor(Color.white);
	          g.draw(gp);
		  if(choice==0) z.x=Particle.nextP(p,q,z.x);
		  if(choice==1) z.x=Particle.nextQ(p,q,z.x);
		 }
	    }
	makeFrame(g);
	gp.reset();
	gp.moveTo(-1+P,-1);
	gp.lineTo(-1+P, 1);
	gp.moveTo(1-P,-1);
	gp.lineTo(1-P, 1);
	gp=transform(gp);
	g.setColor(Color.blue);
	g.draw(gp);
    }

    public void hitset(Graphics2D g) {
	int s=M.QS.DIRECTION.mode;
	if(s!=2) return;
	for(int i=-1;i<2;++i) {
	    for(int j=-1;j<2;++j) {
		PolygonWrapper X=hitset(i,j);
	        Path2D.Double gp=X.toPath2D();
		fillPoly(g,gp,new Color(255,255,255,100));
		gp.reset();
		gp.moveTo(X.z[0].x,X.z[0].y);
		gp.lineTo(X.z[4].x,X.z[4].y);
		gp.moveTo(X.z[1].x,X.z[1].y);
		gp.lineTo(X.z[6].x,X.z[6].y);
		gp.moveTo(X.z[2].x,X.z[2].y);
		gp.lineTo(X.z[5].x,X.z[5].y);
		gp=transform(gp);
		g.setColor(new Color(0,200,200));
		g.draw(gp);
	    }
	}
    }

    public PolygonWrapper hitset(int i,int j) {
	double P=M.QS.getParameter();
	double[][] d={{-1,-1},{-1+P,-1+P},{1-P,-1},{1,-1+P},
                      {1,1},{1-P,1-P},{-1+P,1},{-1,1-P}};
	PolygonWrapper X=new PolygonWrapper();
	X.count=8;
	for(int k=0;k<8;++k) {
             X.z[k]=new Complex(d[k][0],d[k][1]);
	     X.z[k]=Complex.plus(X.z[k],new Complex(2*i,2*j+i*P));
	}
				 
	return X;
    }


    public void drawBarriers(Graphics2D g) {
	int count=0;  
	int s=0;
	double t=0;
	double P=1/2;
	int dyn=1;
	int select=-1;
	try{
	   s=M.QS.DIRECTION.mode;   
           t=M.QS.getSlice();
	   P=M.QS.getParameter();
	   dyn=M.QS.getDynamics();
	   select=M.Z.SC.AVOID.val;
	}
	catch(Exception e) {}
	if(select==-1) return;
	int[] I=DataEdgeCrossing.index(select);
	int choice=-1;
	if((I[2]==0)&&(I[3]==0)) choice=0;
	if((I[2]==0)&&(I[3]==1)) choice=1;
	if((I[2]==1)&&(I[3]==1)) choice=7;
	if((I[2]==3)&&(I[3]==1)) choice=2;
	if((I[2]==3)&&(I[3]==2)) choice=4;
	if((I[2]==4)&&(I[3]==0)) choice=2;
	if((I[2]==4)&&(I[3]==3)) choice=4;
	if((I[2]==6)&&(I[3]==3)) choice=6;
	if((I[2]==7)&&(I[3]==2)) choice=5;
	if((I[2]==7)&&(I[3]==3)) choice=3;
	if(choice==-1) return;
        Polytope POLY=AllPolytopes.plaidBarrier(choice);
	PolygonWrapper SPOLY=POLY.slice(s,t,P);
	Path2D.Double gp=SPOLY.toPath2D();
	Color C=new Color(0,0,255,80);
	fillPoly(g,gp,C);
    }



    public void plotHitset(Graphics2D g) {
	int p=M.p();
	int q=M.q();
	double A=1.0*p/q;
	double P=2.0*p/(p+q);
	int w=p+q;
	Path2D.Double gp=new Path2D.Double();
	for(int i=0;i<w*w;++i) {
	    for(int j=0;j<w;++j) {	 
              if(AGLattice.goodPoint(p,q,i+.5,j+.5)==true) {
                Complex w1=AGLattice.nearestGrid(p,q,i+.5,j+.5);
		double[] U=PlaidClassifyingMap.mapBasic(P,i+.5,j+.5); 
 	  
                gp=makeSquare(p,q,U[0],U[1]);
		gp=transform(gp);
		g.setColor(Color.red);
		double test=w1.y-Math.floor(w1.y);
		if(test>P) g.setColor(Color.blue);
		g.fill(gp);

                gp=makeSquare(p,q,U[0]-2,U[1]-P);
		gp=transform(gp);
		if(test>P) g.setColor(Color.blue);
		g.fill(gp);

	      }
	    }
	}
	makeFrame(g);
    }


    public void makeFrame(Graphics2D g) {
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(-1,-1);
	gp.lineTo(-1,1);
	gp.lineTo(1,1);
	gp.lineTo(1,-1);
	gp.closePath();
	gp=transform(gp);
	g.setColor(new Color(255,255,255,50));
	g.draw(gp);
    }


    public Path2D.Double makeSquare(int p,int q,double x0,double x1) {
	Path2D.Double gp=new Path2D.Double();
	double y=1.0/(p+q);
	gp.moveTo(x0-y,x1-y);
	gp.lineTo(x0+y,x1-y);
	gp.lineTo(x0+y,x1+y);
	gp.lineTo(x0-y,x1+y);
	gp.closePath();
	return(gp);
    }


    public void sendPoint() {
	if(M.QS.DIRECTION.mode!=2) return;
	try{
           double t=M.QS.getSlice();
	   double P=M.QS.getParameter();
	   Vector4 V=new Vector4(SOURCE.x,SOURCE.y,t,P);
	   V=PlaidToGraph.convert(V);
	   V=AGMap.reduceLattice(V);
           int mode=M.GS.DIRECTION.mode;
	   if(mode!=2) return;
           M.GS.PAR=V.x[3];
	   M.GS.S[2]=V.x[2];
	   M.G.SOURCE=new Complex(V.x[0],V.x[1]);
	   }
    catch(Exception e) {}
    }




    public void mousePressed(MouseEvent e) { }

    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	doMouseClick(J.mode);
    }

    public void doMouseClick(int mode) { 
        if(mode==1)  scaleUp(JX,0);
        if(mode==3)  scaleUp(JX,1);
	if(mode==2)  {
            SOURCE=unTransform(JX);
	    SOURCE.print();
	    sendPoint();
	}
	M.repaint();
    }

     public void mouseReleased(MouseEvent e) {	 
     }

    public void mouseEntered(MouseEvent e) {
	requestFocus();
    }
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {
	MouseData J=MouseData.process(e);  
	JX=J.X;
     }

   

    public void mouseDragged(MouseEvent e) {
	MouseData J=MouseData.process(e);
	if(J.mode==2)  {
            SOURCE=unTransform(J.X);
	    sendPoint();
	}
	M.repaint();
    }

    public void keyTyped(KeyEvent e) {
	char ch=e.getKeyChar();
	int test=0;
	if(ch=='z') test=1;
	if(ch=='x') test=2;
	if(ch=='c') test=3;
	if(test>0) doMouseClick(test);
    }

 
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {}


}

