import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


/**This uses the reconstruction formula to check for the first
   16 recalcitrant crossings that the offending edge really does
   stretch across the vertical line mentioned
   in the paper. */

public class ProofCatches {


    public static void main() {

	for(int i=0;i<23;++i) {
	    int[] t=DataEdgeCrossing.recalcitrant(i);
	    boolean test=false;
	    if(t[2]==1) test=test1(t);
	    if(t[2]==3) test=test2(t);
	    System.out.println(i+" "+test);
	}
    }


    /**As usual, these polytopes are scaled up by a
       factor of 60*/

    public static boolean test1(int[] t) {
	PolytopeLong P=AllPolytopesLong.graphTriple(t[0]);
	for(int i=0;i<P.count;++i) {
            long x=P.V[i].x[0];
	    long A=P.V[i].x[3];
	    if(x>A) return false;
	}
	return true;
    }

    public static boolean test2(int[] t) {
	PolytopeLong P=AllPolytopesLong.graphTriple(t[0]);
	for(int i=0;i<P.count;++i) {
            long x=P.V[i].x[0];
            long y=P.V[i].x[1];
	    long A=P.V[i].x[3];
	    if(x<0) return false;
	    if(y<60-A) return false;
	    if(y>60+A) return false;
	}
	return true;
    }

}


