import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


/**This checks the dynamics of the curve following map for the plaid triples.
For certain of the pieces, we want to see which other pieces they are mapped
over when the curve following dynamics (either forwards of backwads) is applied.
You can edit the file and run the routine allDynamics, which will get the
dynamic for all the pieces of the plaid triple partition.  Our routine is
only rigorous in that it returns a list of the only POSSIBLE pieces that
a given triple can map over. The true list might be a proper subset of the
list generated here.  However, this is not important for our proof.*/


public class ProofDynamics {


    public static void main() {
	allDynamics(1);
	allDynamics(2);
    }


    public static void allDynamics(int choice) {
	if((choice!=1)&&(choice!=2)) return;
	if(choice==1) System.out.println("forward dynamics: start");
	if(choice==2) System.out.println("backward dynamics: start");
	for(int i=0;i<218;++i) {
	    System.out.print(i+": ");
	    int[] overlap=getOverlap(choice,i);
	    for(int j=0;j<overlap.length;++j) {
                System.out.print(overlap[j]+" ");
	    }
	    System.out.println("");
	}
	System.out.println("done");
    }



    /**Here i=1,2 and k comes from some special list of
       interest to us.*/

    public static int[] getOverlap(int dir,int k) {
	PolytopeLong P=AllPolytopesLong.plaidTriple(k);
	int[] code=DataTripleCodes.data(k);
	P.type[1]=code[2];
	P.type[2]=code[3];
	PolytopeLong Q=AllPolytopesLong.plaidMap(dir,P);
	int[] overlap=notDisjoint(Q);
	return(overlap);
    }



    public static int[] notDisjoint(PolytopeLong Q) {
	int[] overlap=new int[218];
	int count=0;
	for(int i0=-2;i0<3;++i0) {
	for(int i1=-2;i1<3;++i1) {
	for(int i2=-2;i2<3;++i2) {
	    for(int k=0;k<218;++k) {
		PolytopeLong P=AllPolytopesLong.plaidTriple(k);
		P=AllPolytopesLong.plaidShift(i0,i1,i2,P);
		boolean test=Q.isDisjoint(P);
		if(test==false) {
		    overlap[count]=k;
		    ++count;
		}
	    }
	}}}
	return ListHelp.trim(overlap,count);
    }


}


