import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;
import java.util.Arrays;


public class SpiderRender {
    Manager M;
    Color[] COLOR=new Color[7];
    Point JX;


    public static PolygonWrapper shift(double x,double y,PolygonWrapper P) {
	Complex w=new Complex(x,y);
	PolygonWrapper Q=new PolygonWrapper(P);
	Q.count=P.count;
	for(int i=0;i<P.count;++i) Q.z[i]=Complex.plus(Q.z[i],w);
	return(Q);
    }

    public static void drawSpider(Manager M,ScaleCanvas X,Graphics2D g) {
	double A=M.GS.PAR;
	PolygonWrapper[] S=getSpider(M,A);
	for(int i=0;i<S.length;++i) {
	    for(int k=-2;k<3;++k) {
	      for(int j=-2;j<3;++j) {
	         g.setColor(M.Z.SC.COL[S[i].edge]);
	         PolygonWrapper Q=shift(k,j*(1+A),S[i]);
	         Path2D.Double gp=Q.toPath2D();
	         gp=X.transform(gp);
	         g.fill(gp);
	         g.setColor(Color.white);
	         g.draw(gp);
	      }
	    }
	}
    }

    public static PolygonWrapper[] getSpider(Manager M,double A) {
	PolygonWrapper[] LIST=new PolygonWrapper[16];
	int count=0;
	for(int i=0;i<3;++i) {
	    for(int j=0;j<3;++j) {
		for(int f=0;f<2;++f) {
		    PolygonWrapper S=getSpider(M,i,j,f,A);
		    if((S!=null)&&(M.Z.SC.on[i][j]==1)) {
			LIST[count]=new PolygonWrapper(S);
			++count;
		    }
		}
	    }
	}

	return ListHelp.trim(LIST,count);
    }

    public static PolygonWrapper getSpider(Manager M,int i,int j,int f,double A) {
	int mode=M.Z.SC.MODE.mode;
	int edge=M.Z.SC.EDGE;
	PolygonWrapper S=Spider.getSpider(i,j,f,A);
	if(S==null) return(null);
	if(mode==1) return(S);
	if(S.edge==edge) return(S);
	return(null);
    }





    /**This does the sanity check for the spider sets*/

    public static void drawSpiderCheck(Manager M,ScaleCanvas X,Graphics2D g) {
	Path2D.Double gp1=new Path2D.Double();
	Path2D.Double gp2=new Path2D.Double();
	Path2D.Double gp3=new Path2D.Double();
	int p=M.C.PAR.getNumerator();
	int q=M.C.PAR.getDenominator();
	double A=1.0*p/q;
	int k=p+q;

	double[] U={0,0,0,0};
        for(int i=0;i<2*k;++i) {
	   for(int j=0;j<2*k;++j) {
                Complex w1=AGLattice.nearestGrid(p,q,.5*i,.5*j);
		if(w1!=null) {
		  Complex w2=AGTransforms.p2kAffine(p,q,w1);
		  double[] d=AGMap.phi(p,q,w2.x,w2.y);
		  gp1=GraphicsHelp.makeSquare(p,q,d[1]-1-A,d[2]);
		  gp2=GraphicsHelp.makeSquare(p,q,d[1]-0,d[2]);
		  gp3=GraphicsHelp.makeSquare(p,q,d[1]+1+A,d[2]);
		  g.setColor(new Color(150,150,150));
		  String S=Spider.codon(p,q,w1);
		  int u=M.Z.SC.choice;
		  S=S.substring(u,u+1);
		  if(S.equals("0")==true) g.setColor(M.Z.SC.COL[0]);
	          if(S.equals("1")==true) g.setColor(M.Z.SC.COL[1]);
		  if(S.equals("2")==true) g.setColor(M.Z.SC.COL[2]);
		  if(S.equals("3")==true) g.setColor(M.Z.SC.COL[3]);
		  gp1=X.transform(gp1);
		  gp2=X.transform(gp2);
		  gp3=X.transform(gp3);
		  g.fill(gp1);
		  g.fill(gp2);
		  g.fill(gp3);
		}
	   }
	}
    }


}

